<?php


namespace App\Jobs;

use App\Services\BetService;
use App\Services\LogService;
use App\Services\PcIssueService;
use Exception;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldBeUnique;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use App\Services\IssueService;
use Illuminate\Support\Facades\Log;

class FiveSecondTaskJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * 任务尝试次数
     */
    public $tries = 3;

    /**
     * 任务超时时间（秒）
     */
    public $timeout = 30;


    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        try {
//            Log::error('🚀 开始执行15秒任务: ' . now());
            //（极速28）自定义开奖
            PcIssueService::index();

            // 提前60秒秒提醒封盘倒数
            IssueService::syncCountdownIssue();

            // 停止下注  //封盘
            IssueService::syncCloseIssue();

            // 获取最新的期号
            IssueService::getLatestIssue();

            //随机虚拟投注
           BetService::randomVirtualBetting(3);

            // 重要：使用类名而不是 self()，避免递归
            FiveSecondTaskJob::dispatch()->delay(now()->addSeconds(15));

//            Log::error('📅 下一个15秒任务已安排');

        } catch (Exception $e) {
            try {
                throw new Exception('❌ 15秒任务执行异常: ' . $e->getMessage());
            }catch (Exception $e) {
               LogService::error($e);
            }
            // 异常后15秒重试
            FiveSecondTaskJob::dispatch()->delay(now()->addSeconds(15));
        }
    }

    // 可选：失败处理
    public function failed(\Throwable $exception)
    {
        Log::error('任务失败: ' . $exception->getMessage());

        // 可选：重新分发或通知
        dispatch(new self())->delay(now()->addSeconds(15));
    }
}
